<?php
/*	csv_import : CSVインポート
	name : CSVインポート
	author: team1/3
	CSVファイルをインポートする
*/

	global $html,$params,$database,$config,$ut,$plugin_ar;

	if (!isset($config)) { die(); }
	
	draw();
	
	$params['rendering'] = false;

function draw()
{
	global $html,$params,$database,$ut;
	
	$page_ar = &$params['page'];
	$p_page = $page_ar['id'];

	if (check_rights('owner')) {
		set_func_right('edit.modules');
		set_func_right('add_page');
		provide_edit_rights();
		provide_edit_module();
	}

	if (isset($_GET['mode']) && $_GET['mode'] == 'edit') {
		// 編集
		provide_edit_module();
		unset($params['breadcrumb']);
		snippet_breadcrumb($p_page, 'Page Edit');
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);
		return;

	} else {
		// 通常表示
		snippet_breadcrumb($page_ar['link'], $page_ar['title']);

		write_csv_import($page_ar);
	}
}

function write_csv_import( &$page_ar )
{
	global $params, $ut, $html, $database, $plugin_ar;

	$id = $page_ar['id'];

	
	$ar = $database->sql_select_all("select id,metadata from ".DBX."data_items where type=? and id=? ", $page_ar['type'], $id);
	if ($ar) {
		$m = unserialize64($ar[0]['metadata']);
	}

	//$html['article'][] = frame_renderer(body_renderer($page_ar));	// 通常ページ部分

	if (empty($_FILES['csv_import_file'])) {
$buff = <<<EOT
		<div style = 'background-color: #E8E8E8;'>
			<h2 style='margin: 0;padding: 10px 10px 0 10px;'>CVS インポートプラグインの使い方</h2>
			<div style = 'padding: 0 0 20px 20px;'>
				<p>CSVファイルを読み込み、このページの下層ページとして追加します</p>
				<ul>
					<li>CSVファイル名を指定して、importをクリックしてください</li>
					<li>CSVの先頭行には必ず項目名を付けてください</li>
					<li>CSVのファイルはUTF-8形式です（メモ帳で変換できます）</li>
					<li>CSVのカラム名を"title"にするとそのカラムをページタイトルに設定します</lo>
					<li>CSVのカラムを"folder"にすると、下層フォルダを作りその直下にページを作ります</lo>
					<li>CSVのカラムを"date"にするとそのカラムをページ作成日に設定します</lo>
					<li>CSVのカラムを空白にすると、そのカラムはインポートされません</lo>
					<li>deleteボタンをクリックすると直下のフォルダ/ファイルがすべて削除されます</li>
					<li>インポート後は、プラグインを解除してください</li>
					<li>このページにフォルダプラグイン等を適用して下層ページが表示されるようにしてください</li>
				</ul>
			</div>
		</div>
EOT;
$buff .= <<<EOT
		<div class='edit_pointer'>
			<span onclick='ot.page_setting({$page_ar['id']})' title='Property' >{$ut->icon('setting')}</span> 
		</div>
EOT;
		$html['article'][] = frame_renderer($buff);
	}

	$buff = my_csv_import($arg);
	
	$html['article'][] = frame_renderer($buff,'csv_import-unit');

	if (!isset($html['head']['csv_import'])) {
$html['head']['csv_import'] = <<<EOT
		<style>
		</style>
EOT;
	}

	
	$html['article'][] = innerpage_renderer($page_ar);

	return;
}


function my_csv_import( &$arg )
{
	global $params, $ut, $database, $html;


	$buff = '';
	if (check_rights('edit')) {
$buff .= <<<EOT
		<form method="post" enctype='multipart/form-data' action="{$_SERVER['REQUEST_URI']}" style = 'background-color: #E8E8E8;'>
			<table class='onethird-setting'>
				<tr>
					<td style='vertical-align: top;'>CSV File</td>
					<td>
						<input type='file' name='csv_import_file' />
						<input type='submit' value='import' name='import' />
						<input type='submit' value='delete' name='delete' class='mini' />
						<input type='hidden' name='xtoken' value='{$params['login_user']['meta']['magic_str']}' />
					</td>
				</tr>
			</table>
		</form>
EOT;
		if (!empty($_POST['delete'])) {
			
			$link = $params['page']['link'];
			$ar = array();
			get_linked_pages( $params['page']['id'], $ar );
			array_shift($ar);
			if (!remove_pages($ar)) {
				return false;
			}
			regenerate_attached( $params['page']['id'], true );

		} else if (!empty($_FILES['csv_import_file'])) {
			$file1 = $_FILES['csv_import_file'];

			$file1tmp   = $_FILES['csv_import_file']['tmp_name'];		//tmpファイル名
			$file1name  = $_FILES['csv_import_file']['name'];			//ローカルファイル名
			$file1size  = $_FILES['csv_import_file']['size'];			//ファイルサイズ
			$file1type  = $_FILES['csv_import_file']['type'];			//ファイルの種類
			
			$info = pathinfo($file1name);

			if (is_uploaded_file($file1tmp)) {

				try {
					$file = new SplFileObject($file1tmp); 
				} catch (RuntimeException $e) {
					$file = null;
				}
				
				if ($file) {
					$file->setFlags(SplFileObject::READ_CSV); 
					$idx = false;
					$folder = false;
					$database->sql_begin();
					$count_c = 0;
					$count_e = 0;
					$count_b = 0;
					$count_f = 0;
					$count_notitle = 0;
					foreach ($file as $line) {
						if (!$idx) {
							$idx = $line;
							$format = '';
$format .= <<<EOT
							{\$plugin('embed','start','mode:inline')}
							<table class="event-table">
							<tbody>
EOT;
							$i = 0;
							foreach ($line as $v) {
								++$i;
								if (!$v) { continue; }
								if ($v == 'folder') {
									$folder = $i-1;
								}
$format .= <<<EOT
								<tr>
								<th>{$v}</th>
								<td>{\$plugin('embed','edit','name:field{$i}')}</td>
								</tr>
EOT;
								
							}
$format .= <<<EOT
							</tbody>
							</table>
							<p>{\$plugin('embed','save')}</p>
EOT;
							continue;
						}
						//各ページ作成
						$r = array();
						$r['link'] = $params['page']['id'];
						$r['title'] = '';
						$ok = 0;
						$m = array();
						$c = count($idx);
						for ($i =0; $i < $c; ++$i) {
							if (empty($idx[$i]) || empty($line[$i])) { continue; }
							$v = $line[$i];
							if ($i == $folder) {
								//フォルダ作成
								$ar = $database->sql_select_all("select id from ".DBX."data_items where link=? and title=?", $params['page']['id'], $v);
								if ($ar && $ar[0]) {
									$r['link'] = $ar[0]['id'];
								} else {
									$f = array();
									$f['type'] = PAGE_FOLDER_ID;
									$f['title'] = $v;
									$f['block_type'] = 1;
									$f['mode'] = 1;
									$f['meta']['csv_import'] = true;
									$f['link'] = $params['page']['id'];
									
									if (create_page( $f )) {
										$r['link'] = $f['id'];
										++$count_f;
									} else {
										$buff .= "folder error {$v} - ".__LINE__."<br />";
									}
								}
							}
							if ($idx[$i] == 'title') {
								$r['title'] = $v;
							} else if ($idx[$i] == 'date') {
								$r['date'] = $v;
							}
							if ($v) {
								$m['plugin_embed']["field{$i}"] = str_replace("\n","<br />",$v);
								++$ok;
							}
						}
						$r['type'] = TOPIC_ITEM_ID;
						$r['contents'] = $format;
						$r['meta'] = $m;
						$r['meta']['csv_import'] = true;
						$r['mode'] = 1;
						if ($ok) {
							if (!$r['title']) {
								++$count_notitle;
								$r['title'] = "no title {$count_notitle}";
							}
							if (create_page( $r )) {
								++$count_c;
							} else {
								$buff .= "file error {$r['title']} - ".__LINE__."<br />";
								++$count_e;
							}
						} else {
							++$count_b;
						}
					}
					$database->sql_commit();
$buff = <<<EOT
					<div style = 'background-color: #FFE6B8;'>
						<h2 style='margin: 0;padding: 10px 10px 0 10px;'>インポートレポート</h2>
						<div style = 'padding: 0 0 20px 20px;'>
							<p>インポート数 : {$count_c}</p>
							<p>エラー数 : {$count_e}</p>
							<p>ブランクスキップ数 : {$count_b}</p>
							<p>フォルダ作成数 : {$count_f}</p>
							<p>タイトルなし : {$count_notitle}</p>
						</div>
					</div>
EOT;
					$html['article'][] = frame_renderer($buff);
					$buff = '';
				}
			}
		}
	}

	// 表示
	$option = array();
	$option['total'] = 0;
	$option['offset'] = 0;
	$option['page_size'] = 30;
	$mode = '';

	if (isset($_GET['get_ajax']) && $_GET['get_ajax'] == 'plugin_page_folder_read')  {
		$arg['id'] = (int)$_GET['link'];
		if (isset($_GET['offset'])) {
			$option['offset'] = (int)$_GET['offset'];
		}
		$mode = ($_GET['mode'] == 'more') ? 'more': 'open';
	}

	$type = 0;
	$offset_name = 'offset';
	$id = $params['page']['id'];
	$more = false;
	if (isset($arg['id'])) {
		$id = $arg['id'];
	}
	if (isset($arg['type'])) {
		$type = $arg['type'];
	}
	if (isset($arg['more'])) {
		$more = true;
	}
	if (isset($arg['offset_name'])) {
		$offset_name = $arg['offset_name'];
	}
	$option['offset_name'] = $offset_name;
	
	$opt = ' and mode<>2 ';
	if (!check_rights()) {
		$opt = ' and mode=1 ';
	} else if (!check_rights()) {
		$opt = ' and (mode=1 or (mode=0 and user='.(int)($_SESSION['login_id']).' ';
	}

	$ar = $database->sql_select_all("select count(id) as c from ".DBX."data_items where link=? and block_type !=5 $opt", $id);
	if ($ar) {
		$option['total'] = $ar[0]['c'];
	}
	if (isset($_GET[$offset_name])) {
		$option['offset'] = (int)$_GET[$offset_name];
	}
	if (isset($arg['page_size'])) {
		$option['page_size'] = (int)$arg['page_size'];
	}

	if (!isset($arg['order']) || $arg['order'] == 'desc') {
		$order = 'order by date desc';
	} else {
		$order = 'order by date asc';
	}
	
	// write foloder
	$sql = "select id,type,metadata,title,mode,user,date from ".DBX."data_items ";
	$sql .= " where link=? and block_type !=5";
	$sql .= " and type=".PAGE_FOLDER_ID;
	$sql .= " $opt $order";
	$folder_ar = $database->sql_select_all($sql, $id);

	// write page
	$sql = "select id,type,metadata,title,mode,user,date from ".DBX."data_items ";
	$sql .= " where link=? and block_type !=5";
	if ($type) {
		$sql .= " and type={$type} ";
	} else {
		$sql .= " and type <>".PAGE_FOLDER_ID;
	}
	$sql .= " $opt $order";
	$sql .= " {$ut->limit($option['offset']*$option['page_size'], $option['page_size'])} ";
	
	$ar = $database->sql_select_all($sql, $id);
	$c = count($ar);
	if (!isset($arg['writer'])) {
		if (isset($plugin_ar[ PAGE_FOLDER_ID ]['writer'])) {
			reset($plugin_ar[ PAGE_FOLDER_ID ]['writer']);
			$arg['writer'] = key($plugin_ar[ PAGE_FOLDER_ID ]['writer']);
		} else {
			$arg['writer'] = 'my_csv_import_writer';
		}
	}
	if ($mode != 'more') {
		$ar = array_merge($folder_ar,$ar);
	}
	$buff .= $arg['writer']($ar);
	
	if ($more) {
		if ($c >0 && $c == $option['page_size']) {
			$ofs = $option['offset']+1;
			$buff .= "<p id='plugin_page_folder_more{$id}'><a href='javascript:void(plugin_page_folder_read($id,\"more\",{$ofs}))'>more...</a></p>";
		}
	} else {
		$buff = std_pagination_renderer( $option ).$buff;
	}

	if ($more) {
$html['meta']['page_folder'] = <<<EOT
		<script>
		plugin_page_folder_read = function (link,md,ofs) {
			if (\$('#plugin_page_folder'+link+' .open_hnd').length) {
				\$('#plugin_page_folder'+link+' .open_hnd').toggle();
				return;
			}
			var opt = '';
			opt += "&link="+link;
			if (md) { opt += "&mode="+md; }
			if (ofs) { opt += "&offset="+ofs; }
			\$.ajax({
				type: "POST"
				, url: "{$ut->link($params['page']['id'],'&:get_ajax=plugin_page_folder_read')}"+opt
				, dataType:'json'
				, success: function(data){
					if ( data ) {
						if (data['mode'] == 'open') {
							var a = "<div class='open_hnd' style='padding-left:20px;'>"+data['html']+"</div>";
							\$('#plugin_page_folder'+data['id']).append(a);
						} else {
							\$('#plugin_page_folder_more'+data['id']).after(data['html']).remove();
						}
					}
				}
			});
		};
		</script>
EOT;
	}

	if (isset($_GET['get_ajax']) && $_GET['get_ajax'] == 'plugin_page_folder_read')  {
		$r = array();
		$r['id'] = $id;
		$r['mode'] = $mode;
		$r['url'] = $ut->link($id);
		$r['html'] = $buff;
		$r['ar'] = $ar;
		echo( json_encode($r) );
		exit();
	}

	return $buff;
}

function my_csv_import_writer( &$ar )
{
	global $ut,$html,$config,$params;

	$buff = '';
	$nt = time();
	foreach ($ar as $v) {
		$t = $v['title'];
		$ico = '';
		if (!$t) { $t = '...'; }
		$u = $ut->link($v['id']);
		if ($v['type'] == PAGE_FOLDER_ID) {
			$ico = $ut->icon('folder',"width='16'");
		}
		if ($v['mode'] == 0) {
			if (!check_rights('edit') && isset($_SESSION['login_id']) && $v['user'] != $_SESSION['login_id']) { continue; }
			$t = $t.$ut->icon('lock','width="16"');
		}
		$d = substr($v['date'],0,10);
$buff .= <<<EOT
		<p id='plugin_csv_import{$v['id']}' >
			{$ico} <a href='{$ut->link($v['id'])}'>{$t}</a> <span class='date'>{$d}</span>
		</p>
EOT;
	}

	return $buff;
}


?>